%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Main program for testing the polyhedral gauge recovery solver 'pgr'.
% See the paper "On the solutio uniqueness characterization in the L1
% norm and polyhedral gauge recovery" (by J.Ch. Gilbert) for more
% information.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%------------------------
% General initializations
%------------------------

  addpath '../src'			% Add the PGR directory to the Matlab path

%------------------------
% Read the problem datafile: uncomment the line corresponding to the
% chosen problem.
%------------------------

  run example_3_3;	% example 3.3 of the paper
% run example_3_4;	% example 3.4 of the paper
% run example_4_10_1;	% example 4.10(1) of the paper
% run example_4_10_2;	% example 4.10(2) of the paper
% run example_zeroval;	% a case of unboundedness

%------------------------
% The main program
%------------------------

  options      = [];
  options.verb = 2;

  fprintf('\n');
  [x,val,info] = pgr (C,D,A,b,options);

  fprintf('\n\nSolution');
  fprintf('\n^^^^^^^^\n');
  fprintf('Optimal value: %12.5e',val);
  fprintf('\nPrimal solution');
  if isfield(info,'unique')
    if info.unique
      fprintf(' (unique):\n');
    else
      fprintf(' (non unique):\n');
    end
  else
    fprintf(':\n');
  end
  fprintf('  %12.5e %12.5e %12.5e %12.5e %12.5e',x);
  fprintf('\n\n');
